## Script (Python) "commande2of"
##bind container=container
##bind context=context
##bind namespace=
##bind script=script
##bind subpath=traverse_subpath
##parameters=
##title=
##
# Example code:


selection = context.portal_selections.getSelectionFor('sales_order_selection',REQUEST=context.REQUEST)
sale_order_list = selection(context=context)
request = context.REQUEST
portal_root = context.portal_url.getPortalObject()
portal_root_path = portal_root.getPhysicalPath()

commande_dict = {}
list = ''
#We check every sales order selected
for sale_order in sale_order_list:
  #We are look every line
  sale_order = sale_order.getObject()
  for line in sale_order.objectValues():
    ref = line.getResourceRelativeUrl()
    target_start_date = line.aq_parent.getTargetStartDate()
    target_stop_date = line.aq_parent.getTargetStopDate()
    if not (commande_dict.has_key(ref)):
      commande_dict[ref]={}
    commande_dict[ref]['resourceValue']=line.getResourceValue()
    commande_dict[ref]['target_start_date']=target_start_date
    commande_dict[ref]['target_stop_date']=target_stop_date
    if not (commande_dict[ref].has_key('predicate')):
      commande_dict[ref]['predicate'] = {}
    for cell in line.objectValues():
      #get the predicate_value so that we can know wich cell it is
      predicate_value_list = cell.getPredicateValueList()
      if predicate_value_list!=None:
        predicate = ''
        predicate_value_list.sort()
        for i in range(0,len(predicate_value_list)):
          if i == 0:
            predicate = predicate_value_list[i]
          else:
            predicate += '@' + predicate_value_list[i]
        quantity = cell.getQuantity()
        if quantity is not None:
          if not commande_dict[ref]['predicate'].has_key(predicate):
            commande_dict[ref]['predicate'][predicate] = quantity
          else:
            commande_dict[ref]['predicate'][predicate] = quantity + commande_dict[ref]['predicate'][predicate]

of_module = context.getPortalObject().ordre_fabrication
of_type = 'Production Order'
of_line_type = 'Production Order Line'
for commande in commande_dict.keys():
  if commande_dict[commande] != {}:
    # create a new OF
    new_id = str(of_module.generateNewId())
    context.portal_types.constructContent(type_name=of_type,container=of_module,id=new_id)
    of=of_module[new_id]
    of.edit(target_start_date=commande_dict[commande]['target_start_date'],
            target_stop_date=commande_dict[commande]['target_stop_date'],
            description='of gnr  partir de commandes pour le %s' % commande)
    # create the new Line inside this OF
    new_id = str(of.generateNewId())
    context.portal_types.constructContent(type_name=of_line_type,container=of,id=new_id)
    of_line=of[new_id]
    # Retrive the base_category_list
    base_category_list = []
    category_list = []
    for predicate in commande_dict[commande]['predicate'].keys():
      predicate_list = predicate.split('@')
      for predicate in predicate_list:
        predicate_base = predicate.split('/')
        predicate_base = predicate_base[0]
        if not (predicate_base in base_category_list):
          base_category_list += [predicate_base]
        if not (predicate in category_list):
          category_list += [predicate]
    of_line.edit(resource_value=commande_dict[commande]['resourceValue'],
                 variation_base_category_list=base_category_list,
                 variation_category_list=category_list)

    # define kw and kwd to give to setCellRange
    kw=()
    for i in range(len(base_category_list)):
      list = []
      for cat in category_list:
        if cat.find(base_category_list[i])==0:
          list += [cat]
      kw += (list,)
    kwd = {'base_id': 'movement'}
    of_line.setCellRange(*kw,**kwd)
    # Define the list of cell to add
    for predicate in commande_dict[commande]['predicate'].keys():
      predicate_list = predicate.split('@')
      quantity = commande_dict[commande]['predicate'][predicate]
      new_cell = of_line.newCell(*predicate_list,**kwd)
      new_cell.edit(quantity=quantity,
                    predicate_value_list=predicate_list,
                    mapped_value_property_list=['quantity','price'],
                    predicate_operator='SUPERSET_OF',
                    domain_base_category_list=base_category_list)



return commande_dict

